Package org.gitana.platform.client.application

# Interface Application

All Superinterfaces:
  `AccessControllable`, `ClusterDataStore`, `Copyable`, `DataStore`, `Document`, `org.gitana.platform.GitanaObject`, `org.gitana.platform.JSONable`, `PlatformDataStore`, `Referenceable`, `Selfable`, `Serializable`, `Teamable`, `TitleDescription`, `Transferable`, `TypedID`

All Known Implementing Classes:
  `ApplicationImpl`

public interface Application extends PlatformDataStore

Author:
  uzi

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`FIELD_DEPLOYMENT_AUTH_GRANT_ID`
`static final String`
`FIELD_DEPLOYMENT_CLIENT_ID`
`static final String`
`FIELD_DEPLOYMENT_DOMAIN`
`static final String`
`FIELD_DEPLOYMENT_SUBDOMAIN`
`static final String`
`FIELD_DEPLOYMENT_WEBHOST`
`static final String`
`FIELD_DEPLOYMENTS`
`static final String`
`FIELD_KEY`
`static final String`
`FIELD_SOURCE`
`static final String`
`FIELD_SOURCE_PUBLIC`
`static final String`
`FIELD_SOURCE_TYPE`
`static final String`
`FIELD_SOURCE_URI`

### Fields inherited from interface org.gitana.platform.client.document.Document

`FIELD_ID, SYSTEM, SYSTEM_CREATED_BY, SYSTEM_CREATED_ON, SYSTEM_MODIFIED_BY, SYSTEM_MODIFIED_ON`

### Fields inherited from interface org.gitana.platform.client.support.TitleDescription

`FIELD_DESCRIPTION, FIELD_TITLE`

## Method Summary

Modifier and Type
Method
Description
`void`
`addDeployment(String key, String webhost, String subdomain, String domain, com.fasterxml.jackson.databind.node.ObjectNode config)`
`Email`
`createEmail()`
`Email`
`createEmail(com.fasterxml.jackson.databind.node.ObjectNode object)`
`Email`
`createEmail(DomainUser to, String subject, String body, String fromEmailAddress)`
`Email`
`createEmail(DomainUser to, String subject, String body, String fromEmailAddress, String ccEmailAddresses, String bccEmailAddresses)`
`Email`
`createEmail(DomainUser to, String subject, Node node, String attachmentId, String fromEmailAddress)`
`Email`
`createEmail(DomainUser to, String subject, Node node, String attachmentId, String fromEmailAddress, String ccEmailAddresses, String bccEmailAddresses)`
`EmailProvider`
`createEmailProvider()`
`EmailProvider`
`createEmailProvider(com.fasterxml.jackson.databind.node.ObjectNode object)`
`Registration`
`createRegistration(com.fasterxml.jackson.databind.node.ObjectNode object)`
`Registration`
`createRegistration(String email)`
`Settings`
`createSettings(com.fasterxml.jackson.databind.node.ObjectNode object)`
`void`
`deleteEmail(String emailId)`
`void`
`deleteEmail(Email email)`
`void`
`deleteEmailProvider(String emailProviderId)`
`void`
`deleteEmailProvider(EmailProvider emailProvider)`
`void`
`deleteRegistration(String registrationId)`
`void`
`deleteRegistration(Registration registration)`
`void`
`deleteSettings(String settingsId)`
`void`
`deleteSettings(Settings settings)`
`DeployedApplication`
`deploy(String deploymentKey)`
`DeployedApplication`
`findDeployed(String deploymentKey)`
`com.fasterxml.jackson.databind.node.ObjectNode`
`getDeployment(String key)`
`List<String>`
`getDeploymentKeys()`
`String`
`getKey()`
`Platform`
`getPlatform()`
`boolean`
`getSourcePublic()`
`String`
`getSourceType()`
`String`
`getSourceUri()`
`org.gitana.platform.support.ResultMap<EmailProvider>`
`listEmailProviders()`
`org.gitana.platform.support.ResultMap<EmailProvider>`
`listEmailProviders(org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Email>`
`listEmails()`
`org.gitana.platform.support.ResultMap<Email>`
`listEmails(org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Registration>`
`listRegistrations()`
`org.gitana.platform.support.ResultMap<Registration>`
`listRegistrations(org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Settings>`
`listSettings()`
`org.gitana.platform.support.ResultMap<Settings>`
`listSettings(org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<EmailProvider>`
`queryEmailProviders(com.fasterxml.jackson.databind.node.ObjectNode query)`
`org.gitana.platform.support.ResultMap<EmailProvider>`
`queryEmailProviders(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Email>`
`queryEmails(com.fasterxml.jackson.databind.node.ObjectNode query)`
`org.gitana.platform.support.ResultMap<Email>`
`queryEmails(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Registration>`
`queryRegistrations(com.fasterxml.jackson.databind.node.ObjectNode query)`
`org.gitana.platform.support.ResultMap<Registration>`
`queryRegistrations(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
`org.gitana.platform.support.ResultMap<Settings>`
`querySettings(com.fasterxml.jackson.databind.node.ObjectNode query)`
`org.gitana.platform.support.ResultMap<Settings>`
`querySettings(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
`Map<String,Map<String,String>>`
`readApiKeys()`
`Map<String,String>`
`readApiKeys(String deploymentKey)`
`Settings`
`readApplicationPrincipalSettings(String domainId, String principalId)`
`Settings`
`readApplicationPrincipalSettings(DomainPrincipal principal)`
`Settings`
`readApplicationSettings()`
`Settings`
`readApplicationSettings(String scope, String key)`
`Email`
`readEmail(String emailId)`
`EmailProvider`
`readEmailProvider(String emailProviderId)`
`Registration`
`readRegistration(String registrationId)`
`Settings`
`readSettings(String settingsId)`
`void`
`removeDeployment(String key)`
`void`
`setKey(String key)`
`void`
`setSource(String type, boolean isPublic, String uri)`
`void`
`updateEmail(Email email)`
`void`
`updateEmailProvider(EmailProvider emailProvider)`
`void`
`updateRegistration(Registration registration)`
`void`
`updateSettings(Settings settings)`

### Methods inherited from interface org.gitana.platform.client.support.AccessControllable

`getACL, getACL, getAuthorityGrants, grant, grant, hasAuthority, hasAuthority, hasPermission, hasPermission, revoke, revoke, revokeAll, revokeAll`

### Methods inherited from interface org.gitana.platform.client.cluster.ClusterDataStore

`getCluster`

### Methods inherited from interface org.gitana.platform.client.support.Copyable

`copy, copy, copyAsync, copyAsync`

### Methods inherited from interface org.gitana.platform.client.document.Document

`dateCreated, dateModified, getCreatedBy, getId, getModifiedBy, getSystemObject, isSaved, reload, reload, setId, setSaved`

### Methods inherited from interface org.gitana.platform.GitanaObject

`get, getArray, getAsJsonNode, getBigDecimal, getBoolean, getDouble, getInt, getLong, getObject, getObject, getString, has, putAll, putAll, remove, set`

### Methods inherited from interface org.gitana.platform.JSONable

`toJSON, toJSONString`

### Methods inherited from interface org.gitana.platform.client.support.Referenceable

`ref`

### Methods inherited from interface org.gitana.platform.client.support.Selfable

`delete, reload, update`

### Methods inherited from interface org.gitana.platform.client.team.Teamable

`createTeam, createTeam, deleteTeam, getOwnersTeam, getTeamableBaseUri, listTeams, readTeam`

### Methods inherited from interface org.gitana.platform.client.support.TitleDescription

`getDescription, getTitle, setDescription, setTitle`

### Methods inherited from interface org.gitana.platform.client.support.Transferable

`exportArchive, exportArchive, exportArchive, importArchive, importArchive, importArchive`

### Methods inherited from interface org.gitana.platform.client.support.TypedID

`getId, getTypeId`

## Field Details

### FIELD_KEY

static final String FIELD_KEY

See Also:
  - Constant Field Values

### FIELD_DEPLOYMENTS

static final String FIELD_DEPLOYMENTS

See Also:
  - Constant Field Values

### FIELD_DEPLOYMENT_WEBHOST

static final String FIELD_DEPLOYMENT_WEBHOST

See Also:
  - Constant Field Values

### FIELD_DEPLOYMENT_SUBDOMAIN

static final String FIELD_DEPLOYMENT_SUBDOMAIN

See Also:
  - Constant Field Values

### FIELD_DEPLOYMENT_DOMAIN

static final String FIELD_DEPLOYMENT_DOMAIN

See Also:
  - Constant Field Values

### FIELD_DEPLOYMENT_CLIENT_ID

static final String FIELD_DEPLOYMENT_CLIENT_ID

See Also:
  - Constant Field Values

### FIELD_DEPLOYMENT_AUTH_GRANT_ID

static final String FIELD_DEPLOYMENT_AUTH_GRANT_ID

See Also:
  - Constant Field Values

### FIELD_SOURCE

static final String FIELD_SOURCE

See Also:
  - Constant Field Values

### FIELD_SOURCE_TYPE

static final String FIELD_SOURCE_TYPE

See Also:
  - Constant Field Values

### FIELD_SOURCE_PUBLIC

static final String FIELD_SOURCE_PUBLIC

See Also:
  - Constant Field Values

### FIELD_SOURCE_URI

static final String FIELD_SOURCE_URI

See Also:
  - Constant Field Values

## Method Details

### getKey

String getKey()

### setKey

void setKey(String key)

### getPlatform

Platform getPlatform()

Specified by:
  `getPlatform` in interface `PlatformDataStore`
Returns:
  platform

### listSettings

org.gitana.platform.support.ResultMap<Settings> listSettings()

### listSettings

org.gitana.platform.support.ResultMap<Settings> listSettings(org.gitana.platform.support.Pagination pagination)

### readSettings

Settings readSettings(String settingsId)

### createSettings

Settings createSettings(com.fasterxml.jackson.databind.node.ObjectNode object)

### querySettings

org.gitana.platform.support.ResultMap<Settings> querySettings(com.fasterxml.jackson.databind.node.ObjectNode query)

### querySettings

org.gitana.platform.support.ResultMap<Settings> querySettings(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)

### updateSettings

void updateSettings(Settings settings)

### deleteSettings

void deleteSettings(Settings settings)

### deleteSettings

void deleteSettings(String settingsId)

### readApplicationSettings

Settings readApplicationSettings()

### readApplicationSettings

Settings readApplicationSettings(String scope, String key)

### readApplicationPrincipalSettings

Settings readApplicationPrincipalSettings(DomainPrincipal principal)

### readApplicationPrincipalSettings

Settings readApplicationPrincipalSettings(String domainId, String principalId)

### listEmails

org.gitana.platform.support.ResultMap<Email> listEmails()

### listEmails

org.gitana.platform.support.ResultMap<Email> listEmails(org.gitana.platform.support.Pagination pagination)

### readEmail

Email readEmail(String emailId)

### createEmail

Email createEmail()

### createEmail

Email createEmail(com.fasterxml.jackson.databind.node.ObjectNode object)

### createEmail

Email createEmail(DomainUser to, String subject, String body, String fromEmailAddress)

### createEmail

Email createEmail(DomainUser to, String subject, String body, String fromEmailAddress, String ccEmailAddresses, String bccEmailAddresses)

### createEmail

Email createEmail(DomainUser to, String subject, Node node, String attachmentId, String fromEmailAddress)

### createEmail

Email createEmail(DomainUser to, String subject, Node node, String attachmentId, String fromEmailAddress, String ccEmailAddresses, String bccEmailAddresses)

### queryEmails

org.gitana.platform.support.ResultMap<Email> queryEmails(com.fasterxml.jackson.databind.node.ObjectNode query)

### queryEmails

org.gitana.platform.support.ResultMap<Email> queryEmails(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)

### updateEmail

void updateEmail(Email email)

### deleteEmail

void deleteEmail(Email email)

### deleteEmail

void deleteEmail(String emailId)

### listEmailProviders

org.gitana.platform.support.ResultMap<EmailProvider> listEmailProviders()

### listEmailProviders

org.gitana.platform.support.ResultMap<EmailProvider> listEmailProviders(org.gitana.platform.support.Pagination pagination)

### readEmailProvider

EmailProvider readEmailProvider(String emailProviderId)

### createEmailProvider

EmailProvider createEmailProvider()

### createEmailProvider

EmailProvider createEmailProvider(com.fasterxml.jackson.databind.node.ObjectNode object)

### queryEmailProviders

org.gitana.platform.support.ResultMap<EmailProvider> queryEmailProviders(com.fasterxml.jackson.databind.node.ObjectNode query)

### queryEmailProviders

org.gitana.platform.support.ResultMap<EmailProvider> queryEmailProviders(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)

### updateEmailProvider

void updateEmailProvider(EmailProvider emailProvider)

### deleteEmailProvider

void deleteEmailProvider(EmailProvider emailProvider)

### deleteEmailProvider

void deleteEmailProvider(String emailProviderId)

### listRegistrations

org.gitana.platform.support.ResultMap<Registration> listRegistrations()

### listRegistrations

org.gitana.platform.support.ResultMap<Registration> listRegistrations(org.gitana.platform.support.Pagination pagination)

### readRegistration

Registration readRegistration(String registrationId)

### createRegistration

Registration createRegistration(com.fasterxml.jackson.databind.node.ObjectNode object)

### createRegistration

Registration createRegistration(String email)

### queryRegistrations

org.gitana.platform.support.ResultMap<Registration> queryRegistrations(com.fasterxml.jackson.databind.node.ObjectNode query)

### queryRegistrations

org.gitana.platform.support.ResultMap<Registration> queryRegistrations(com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)

### updateRegistration

void updateRegistration(Registration registration)

### deleteRegistration

void deleteRegistration(Registration registration)

### deleteRegistration

void deleteRegistration(String registrationId)

### addDeployment

void addDeployment(String key, String webhost, String subdomain, String domain, com.fasterxml.jackson.databind.node.ObjectNode config)

### getDeploymentKeys

List<String> getDeploymentKeys()

### getDeployment

com.fasterxml.jackson.databind.node.ObjectNode getDeployment(String key)

### removeDeployment

void removeDeployment(String key)

### setSource

void setSource(String type, boolean isPublic, String uri)

### getSourceType

String getSourceType()

### getSourcePublic

boolean getSourcePublic()

### getSourceUri

String getSourceUri()

### deploy

DeployedApplication deploy(String deploymentKey)

### findDeployed

DeployedApplication findDeployed(String deploymentKey)

### readApiKeys

Map<String,Map<String,String>> readApiKeys()

### readApiKeys

Map<String,String> readApiKeys(String deploymentKey)